public interface IFoldOperation {
	/**
	 * Perform a fold operation on the provided array of numbers. The provided
	 * argument must satisfy the following conditions :
	 * 
	 * - It is not null. 
	 * - It is not empty.
	 * 
	 * @throws IllegalArgumentException
	 *             in case one of the conditions is violated .
	 * 
	 * @return the result of the fold operation .
	 */
	public double fold(double[] values);
}